import { modifierPhases } from "../enums.js"; // source: https://stackoverflow.com/questions/49875255

var order = function order(modifiers) {
  // indexed by name
  var mapped = modifiers.reduce(function (mem, i) {
    mem[i.name] = i;
    return mem;
  }, {}); // inherit all dependencies for a given name

  var inherited = function inherited(i) {
    var current = mapped[i];
    return current ? [].concat(current.requires || [], current.optionallyRequires || []).reduce(function (mem, i) {
      return [].concat(mem, [i], inherited(i));
    }, []) : [];
  }; // order ...


  var ordered = modifiers.sort(function (a, b) {
    return !!~inherited(b.name).indexOf(a.name) ? -1 : 1;
  });
  return ordered;
};

export default (function (modifiers) {
  return modifierPhases.reduce(function (acc, currentPhase) {
    return acc.concat(order(modifiers.filter(function (modifier) {
      return modifier.phase === currentPhase;
    })));
  }, []);
});